<template>
   <div class="games">
       <header>
           <span>Recruitment Assignment Mr Green</span>
           <span>Joakim Olsson - Mpya Digital</span>
        </header>

       <aside>
           <v-btn
                class="my-1"
                @click="getGames(true)"
                dark
           >Apply filter</v-btn>

           <v-expansion-panels
            accordion
            multiple
            dark
            >
            <v-expansion-panel>
                <v-expansion-panel-header>
                    {{`Providers ${providerFilter.length ? `(${providerFilter.length})` : '' }`}}
                </v-expansion-panel-header>
                <v-expansion-panel-content>
                    <v-layout column>
                        <v-checkbox
                            v-for="provider in providers"
                            :key="provider"
                            v-model="providerFilter" 
                            :label="provider" 
                            :value="provider"
                            dense
                            hide-details
                        />
                    </v-layout>
                </v-expansion-panel-content>
            </v-expansion-panel>

            <v-expansion-panel>
                <v-expansion-panel-header>
                    {{`Collections ${collectionFilter.length ? `(${collectionFilter.length})` : '' }`}}
                </v-expansion-panel-header>
                <v-expansion-panel-content>
                     <v-layout column>
                        <v-checkbox
                            v-for="collection in collections"
                            :key="collection"
                            v-model="collectionFilter" 
                            :label="collection" 
                            :value="collection"
                            dense
                            hide-details
                        />
                    </v-layout>
                </v-expansion-panel-content>
            </v-expansion-panel>
        </v-expansion-panels>
       </aside>

        <main ref="main">
            <span v-if="loading && !games.length">Loading</span>
            <span v-else-if="error">Could not get any games</span>
            <GameList v-else :games="games"/>
        </main>
        
        </div>
</template>

<script>
import GameList from '../components/GameList';
import Api from '@/api'

export default {
    components: {
        GameList,
    },
    data: () => ({
        games: [],
        providers: [],
        collections: [],
        page: 1,
        providerFilter: [],
        collectionFilter: [],
        loading: false,
        error: false,
    }),
    methods: {
        checkScrollPosition() { 
            const bottomOfWindow = Math.abs(this.$refs.main.scrollTop + this.$refs.main.offsetHeight - 
                                            this.$refs.main.scrollHeight) < 5;

            if (bottomOfWindow) {
                this.page++;
                this.getGames();      
            }
        },
        async getGames(reset) {
            this.loading = true;
            
            try {
                const newGames = await Api.get.games(reset ? 1 : this.page, {
                    providers: this.providerFilter,
                    collections: this.collectionFilter
                });
                this.games = reset ? newGames : [...this.games, ...newGames];
            } catch (err) {
                this.error = true;
            }
            
            if(reset) { this.checkScrollPosition(); }
            this.loading = false;
        }
    },
    async beforeMount() {
         this.getGames();
         this.providers = await Api.get.providers();
         this.collections = await Api.get.collections();
    },
    mounted() {
        this.checkScrollPosition();
        this.$refs.main.onscroll = () => {
            this.checkScrollPosition();
        };
    }
};
</script>

<style lang="scss" scoped>
   .games {
        height: 100vh;
        display: grid;
        grid-template-rows: 
            50px  1fr;
        grid-template-columns: 
            350px  1fr;
        grid-template-areas:
            "header header"
            "sidenav main";

        & > aside {
            padding: 0 .5rem;
            grid-area: sidenav;
            overflow: auto;
            background: #333;
            
        }

        & > main {
            grid-area: main;
            overflow: auto;
            background: #134326;
        }

        & > header {
            color: white;
            grid-area: header;
            background: #18723c;
            display: flex;
            justify-content: space-between;
            align-items: center;
            padding: .5rem;
            flex-wrap: wrap;

            span:nth-child(2) {
                font-size: 10px;
            }
        }
    }

    @media only screen and (max-width: 800px) {
        .games {
            grid-template-rows: 
                50px min-content  1fr;
            grid-template-columns: 1fr;
            grid-template-areas:
                "header"
                "sidenav"
                "main";
        }
    }
</style>
